#include <Wire.h>
 
//Direccion I2C de la IMU
#define MPU 0x68
 
//MPU-6050 da los valores en enteros de 16 bits
int GiX, GiY, GiZ;
int AiX, AiY, AiZ;
int iGiX, iGiY, iGiZ;
int iAiX, iAiY, iAiZ;
int vx,vy,vz;
 
int temperatura; 

unsigned int tiempo,time1,time2,time3;

void setup()
{
  Serial.begin(9600);
  Serial.println("__Reset__");
  Wire.begin();
  Wire.beginTransmission(MPU);
  Wire.write(0x6B);
  Wire.write(0);
  Wire.endTransmission(true);
  delay(500);
  leerDatosG();
  iGiX=GiX;  iGiY=GiY;  iGiZ=GiZ;
  leerDatosA();
  iAiX=AiX;  iAiY=AiY;  iAiZ=AiZ;
  Serial.println("_Valores iniciales");
  Serial.print("_X=");Serial.print(GiX);
  Serial.print(" Y=");Serial.print(GiY);
  Serial.print(" Z=");Serial.println(GiZ);
  Serial.print("_aX=");Serial.print(AiX);
  Serial.print(" aY=");Serial.print(AiY);
  Serial.print(" aZ=");Serial.println(AiZ);
  Serial.println("___________________");
  delay(1000);
}


void loop()
{ 
  delay(1);
  tiempo++;  time1++; time2++;time3++;
  if(tiempo>1000)tiempo=0;
  

  if(time1>100)
    {
      time1=0;
      leerDatosA(); 
       vz=AiZ-iAiZ; vz=vz>>7;
       vx=AiX-iAiX; vx=vx>>7;
       vy=AiY-iAiY; vy=vy>>7;
       if(1 || abs(vz)>3 || abs(vx)>3 || abs(vy)>3)
         {
         Serial.print("a,"); 
         Serial.print(vx); Serial.print(","); Serial.print(vy); Serial.print(","); Serial.print(vz);Serial.println(","); 
         }  
    }
    
    
   if(time2>250)
    {
       time2=0;
       leerDatosG();
       vz=GiZ-iGiZ; vz=vz>>8;
       vx=GiX-iGiX; vx=vx>>8;
       vy=GiY-iGiY; vy=vy>>8;
       Serial.print("n,"); Serial.print(vx); Serial.print(","); Serial.print(vy); Serial.print(","); Serial.print(vz);Serial.println(","); 
    }
   
    if(time3>1000)
    {
       time3=0;
       leerDatosT();
       temperatura/=34;   temperatura+=365;
       Serial.print("t,"); Serial.print(temperatura);Serial.println(","); 
    }
  
   
}


void leerDatosT()
{
   Wire.beginTransmission(MPU);
   Wire.write(0x41); //Pedir el registro 0x3B - corresponde al GiX
   Wire.endTransmission(false);
   Wire.requestFrom(MPU,2,true); //A partir del 0x3B, se piden 6 registros
   temperatura=Wire.read()<<8|Wire.read(); //Cada valor ocupa 2 registros
   
}  

void leerDatosA()
{
   Wire.beginTransmission(MPU);
   Wire.write(0x43); //Pedir el registro 0x3B - corresponde al GiX
   Wire.endTransmission(false);
   Wire.requestFrom(MPU,6,true); //A partir del 0x3B, se piden 6 registros
   AiX=Wire.read()<<8|Wire.read(); //Cada valor ocupa 2 registros
   AiY=Wire.read()<<8|Wire.read();
   AiZ=Wire.read()<<8|Wire.read();
}  

void leerDatosG()
{
   Wire.beginTransmission(MPU);
   Wire.write(0x3B); //Pedir el registro 0x3B - corresponde al GiX
   Wire.endTransmission(false);
   Wire.requestFrom(MPU,6,true); //A partir del 0x3B, se piden 6 registros
   GiX=Wire.read()<<8|Wire.read(); //Cada valor ocupa 2 registros
   GiY=Wire.read()<<8|Wire.read();
   GiZ=Wire.read()<<8|Wire.read();
}  
